Registrar(8)

NAME
registrar - RSerPool Pool Registrar (PR) Service

SYNOPSIS
registrar [-announcettl=TTL] [-asap=auto|address:port,address,...] [-asapannounce=auto|address:port] [-autoclosetimeout=seconds] [-endpointkeepalivetransmissioninterval=milliseconds] [-endpointkeepalivetimeoutinterval=milliseconds] [-maxbadpereports=reports] [-maxhresitems=items] [-maxincrement=increment] [-minaddressscope=loopback|sitelocal|global] [-serverannouncecycle=milliseconds] [-enrp=auto|address:port,address,...] [-enrpannounce=auto|address:port] [-maxelementsperhtrequest=items] [-mentordiscoverytimeout=milliseconds] [-peer=address:port] [-peerheartbeatcycle=milliseconds] [-peermaxtimelastheard=millisecond] [-peermaxtimenoresponse=milliseconds] [-takeoverexpiryinterval=milliseconds] [-cspinterval=milliseconds] [-cspserver=address:port] [-logcolor=on|off] [-logappend=filename] [-logfile=filename] [-loglevel=0-9]

DESCRIPTION
registrar provides a registrar service for Reliable Server Pooling (RSerPool) pool elements (PEs) and pool users (PUs). PRs of an operation scope synchronize their view of the handlespace using the Endpoint haNdlespace Redundancy Protocol (ENRP), transported via SCTP. An operation scope has a limited range, e.g. an organization or only a building. In particular, it is restricted to a single administrative domain - in contrast to GRID computing - in order to keep the management complexity at a minimum. Nevertheless, PEs may be distributed globally for their service to survive localized disasters.

PEs choose an arbitrary PR of the operation scope to register into a pool by using the Aggregate Server Access Protocol (ASAP), again transported via SCTP. Upon registration at a PR, the chosen PR becomes the Home-PR (PR-H) of the newly registered PE. A PR-H is responsible for monitoring its PEs' availability by keep-alive messages (to be acknowledged by the PE within a given timeout) and propagates the information about its PEs to the other PRs of the operation scope via ENRP updates.

In order to access the service of a pool given by its PH, a PU requests a PE selection from an arbitrary PR of the operation scope, using the Aggregate Server Access Protocol (ASAP), transported via SCTP. The PR selects the requested list of PE identities by applying a pool-specific selection rule, called pool policy.

In order to allow for automatic configuration, a PR can send out regular announces via an ASAP and ENRP multicast address. PEs and PUs can listen to this address to learn the list of currently available PRs.

ARGUMENTS
The following options are available:

-quiet
    Do not print startup and shutdown messages.

-announcettl=TTL
    Sets the TTL for outgoing ASAP Announce/ENRP Presence messages via multicast.

Logging Parameters:
    It is recommended to use at least a value of 2 to see possibly important error messages and warnings.

    -logcolor=on|off
        Turns ANSI colorization of the logging output on or off.

    -logappend=filename
        Write logging output to a file (default is stdout); output will be appended to given file.

    -logfile=filename
        Write logging output to a file (default is stdout); given file will be overwritten.

    -loglevel=0-9
        Sets the logging verbosity from 0 (none) to 9 (very verbose).

Component Status Protocol (CSP) Parameters:

    -cspinterval=milliseconds
        Sets the interval for the CSP status updates in milliseconds.

    -cspserver=address:port
        Sets the CSP monitor server's address and port.

Aggregate Server Access Protocol (ASAP) Parameters:

    -autoclosetimeout=seconds
        Sets the SCTP autoclose timeout for idle ASAP associations.

    -asap=auto|address:port,address,...
        Sets the ASAP endpoint address(es). Use "auto" to automatically set it (default).

    -asapannounce=auto|address:port
        Sets the multicast address and UDP port to send the ASAP Announces to. Use "auto" to automatically set it (default). Examples:
        -asapannounce=auto
        -asapannounce=239.0.0.1:3863

    -endpointkeepalivetransmissioninterval=milliseconds
        Sets the ASAP Endpoint Keep Alive interval.

    -endpointkeepalivetimeoutinterval=milliseconds
        Sets the ASAP Endpoint Keep Alive timeout.

    -maxbadpereports=reports
        Sets the maximum number of ASAP Endpoint Unreachable reports before removing a PE.

    -maxincrement=increment
        Sets the MaxIncrement constant. Handle with care!

    -maxhresitems=items
        Sets the MaxHResItems constant.

    -minaddressscope=loopback|sitelocal|global
        Sets the minimum address scope acceptable for registered PEs:
        loopback: Loopback address (only valid on the same node!)
        site-local: Site-local addresses (e.g. 192.168.1.1, etc.)
        global: Global addresses

    -serverannouncecycle=milliseconds
        Sets the ASAP Announce interval.

Endpoint Handlespace Redundancy Protocol (ENRP) Parameters:

    -enrp=auto|address:port,address,...
        Sets the ENRP endpoint address(es). Use "auto" to automatically set it (default). Examples:
        -enrp=auto
        -enrp=1.2.3.4:9901
        -enrp=1.2.3.4:9901,[2000::1:2:3],9.8.7.6

    -enrpannounce=auto|address:port
        Sets the multicast address and UDP port to send the ENRP Announces to. Use "auto" to automatically set it (default). Examples:
        -enrpannounce=auto
        -enrpannounce=239.0.0.1:9901

    -maxelementsperhtrequest=items
        Sets the maximum number of items per ENRP Handle Table Response.

    -mentordiscoverytimeout=milliseconds
        Sets the mentor PR discovery timeout in milliseconds.

    -peer=address:port
        Adds a static PR entry into the Peer List. It is possible to add multiple entries.

    -peerheartbeatcycle=milliseconds
        Sets the ENRP peer heartbeat interval.

    -peermaxtimelastheard=milliseconds
        Sets the ENRP peer max time last heard.

    -peermaxtimenoresponse=milliseconds
        Sets the ENRP maximum time without response.

    -takeoverexpiryinterval=milliseconds
        Sets the ENRP takeover timeout.

ENVIRONMENT
registrar uses the environment variables CSP_SERVER and CSP_INTERVAL to define a CSP server to send reports to in the specified interval.

DIAGNOSTICS
If loglevel>0, log messages will be printed to stdout or into a specified log file.

SEE ALSO
For a detailed introduction to RSerPool, see:
http://duepublico.uni-duisburg-essen.de/servlets/DerivateServlet/Derivate-16326/Dre2006-final.pdf

Thomas Dreibholz's RSerPool Page:
http://tdrwww.iem.uni-due.de/dreibholz/rserpool/

AUTHORS
Dr. Thomas Dreibholz
http://tdrwww.iem.uni-due.de/dreibholz/rserpool/
mailto://dreibh@iem.uni-due.de